#include <stdio.h>
#include <stdlib.h>
#include "RIO_2010_AIO.h"

int main(int argc, char *argv[])
{
	int ret, fd;
	unsigned char do_value;

	printf("RIO-2010 DO Read Write Example.\r\n");

	ret = AIO_Init();
	if (ret != AIO_OK) {
		printf("AIO_Init Error: %d.\r\n", ret);
		return -1;
	}
	
	ret = AIO_Connect("192.168.2.127", 502, 1000, &fd);
	if (ret != AIO_OK) {
		printf("AIO_Connect Error: %d.\r\n", ret);
		return -1;
	}

	ret = AIO_RIO_2010_DO_Read(fd, 100, 1, 8, &do_value);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2010_DO_Read Error: %d.\r\n", ret);
	} else {
		printf("DO Read Response: 0x%02x\r\n", do_value);
	}

	do_value = 0x55;
	ret = AIO_RIO_2010_DO_Write(fd, 100, 1, 8, do_value);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2010_DO_Write Error: %d.\r\n", ret);
	} else {
		printf("AIO_RIO_2010_DO_Write %x OK\r\n", do_value);
	}

	do_value = 0x01;
	ret = AIO_RIO_2010_DO_Write_bit(fd, 100, 2, do_value);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2010_DO_Write_bit Error: %d.\r\n", ret);
	} else {
		printf("AIO_RIO_2010_DO_Write_bit OK\r\n");
	}

	AIO_Close(fd);

	printf("Example Exit.\r\n");
	return 0;
}


