#ifndef _RIO_2010_AIO_H
#define _RIO_2010_AIO_H

/* Error Code */
#define AIO_OK	0x00
#define AIO_TIMEOUT			1000
#define AIO_DISCONNECTED	1001
#define AIO_MB_EXCEPTION	1002
#define AIO_UNKNOWN_RESP	1003
#define AIO_ARG_ERROR		1004
#define AIO_LOGIN_FAILED	1005

/* API */
int AIO_Init(void);
/* I/O */
int AIO_Connect(char *ip_str, int port, int tmout_ms, int *socket_fd);

int AIO_Close(int socket_fd);

int AIO_RIO_2010_DI_Read(int socket_fd, int tmout_ms, unsigned char start_no, unsigned char quantity, unsigned char *value_buf, int buf_size, int *value_byte_count);

int AIO_RIO_2010_DO_Read(int socket_fd, int tmout_ms, unsigned char start_no, unsigned char quantity, unsigned char *value);

int AIO_RIO_2010_DO_Write(int socket_fd, int tmout_ms, unsigned char start_no, unsigned char quantity, unsigned char value);

int AIO_RIO_2010_DO_Write_bit(int socket_fd, int tmout_ms, unsigned char start_no, unsigned char value);

int AIO_RIO_2010_Sensor_Read(int socket_fd, int tmout_ms, unsigned char *value_buf, int buf_size, int *response_byte_count);

#endif
