#include <stdio.h>
#include <stdlib.h>
#include "RIO_2017_AIO.h"

void parseAIdata(unsigned char *raw_data_buf, int total_len)
{
	int idx=0;
	unsigned char enable, flag;
	int d_integer, d_decimal;
	do {
		enable = raw_data_buf[idx++];
		flag = raw_data_buf[idx++];
		d_integer = raw_data_buf[idx++]*0x100;
		d_integer += raw_data_buf[idx++];
		d_decimal = raw_data_buf[idx++]*0x100;
		d_decimal += raw_data_buf[idx++];
		printf("AI:");
		if (enable == 0x01) {
			printf("enable,");
		} else {
			printf("disable,");
		}
		printf("Value:");
		if (flag == 0x01) {
			printf("-");
		}
		printf("%d.%d\r\n", d_integer, d_decimal);
	} while(idx < total_len);	
}

int main(int argc, char *argv[])
{
	int i, ret, fd;
	unsigned char response_buf[64];
	int response_byte_count;

	printf("RIO-2017 AI Read Example.\r\n");

	ret = AIO_Init();
	if (ret != AIO_OK) {
		printf("AIO_Init Error: %d.\r\n", ret);
		return -1;
	}
	
	ret = AIO_Connect("192.168.2.127", 502, 1000, &fd);
	if (ret != AIO_OK) {
		printf("AIO_Connect Error: %d.\r\n", ret);
		return -1;
	}

	ret = AIO_RIO_2017_AI_Read(fd, 100, 1, 8, response_buf, sizeof(response_buf), &response_byte_count);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2017_AI_Read Error: %d.\r\n", ret);
		if (ret == AIO_MB_EXCEPTION) {
			printf("Modbus exception code: 0x%02x.\r\n", response_buf[0]);
		}
	} else {
		printf("AI Read Response:\r\n");
		for(i=0; (i<response_byte_count)&&(i<sizeof(response_buf)); i++) {
			if ((i%6)==0 && (i!=0)) {
				printf("\r\n");
			}
			printf("[%02d]:0x%02x,", i, response_buf[i]);
		}
		printf("\r\n");
		parseAIdata(response_buf, response_byte_count);
	}

	AIO_Close(fd);

	printf("Example Exit.\r\n");
	return 0;
}


