#include <stdio.h>
#include <stdlib.h>
#include "RIO_2017_AIO.h"

int main(int argc, char *argv[])
{
	int ret, fd;
	unsigned char do_value;

	printf("RIO-2017 DO Read Write Example.\r\n");

	ret = AIO_Init();
	if (ret != AIO_OK) {
		printf("AIO_Init Error: %d.\r\n", ret);
		return -1;
	}
	
	ret = AIO_Connect("192.168.2.127", 502, 1000, &fd);
	if (ret != AIO_OK) {
		printf("AIO_Connect Error: %d.\r\n", ret);
		return -1;
	}

	ret = AIO_RIO_2017_DO_Read(fd, 100, &do_value);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2017_DO_Read Error: %d.\r\n", ret);
	} else {
		printf("DO Value:0x%02x\r\n", do_value);
	}

	do_value = 0x01;
	ret = AIO_RIO_2017_DO_Write(fd, 100, do_value);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2017_DO_Write Error: %d.\r\n", ret);
	} else {
		printf("AIO_RIO_2017_DO_Write 0x%02x OK\r\n", do_value);
	}

	AIO_Close(fd);

	printf("Example Exit.\r\n");
	return 0;
}


