#ifndef _RIO_2017_AIO_H
#define _RIO_2017_AIO_H

/* Error Code */
#define AIO_OK	0x00
#define AIO_TIMEOUT			1000
#define AIO_DISCONNECTED	1001
#define AIO_MB_EXCEPTION	1002
#define AIO_UNKNOWN_RESP	1003
#define AIO_ARG_ERROR		1004
#define AIO_LOGIN_FAILED	1005

/*AI Range*/
#define AI_RANGE_N150_150MV	0x00
#define AI_RANGE_0_150MV	0x01
#define AI_RANGE_N500_500MV	0x02
#define AI_RANGE_0_500MV	0x03
#define AI_RANGE_N1_1V		0x04
#define AI_RANGE_0_1V		0x05
#define AI_RANGE_N5_5V		0x06
#define AI_RANGE_0_5V		0x07
#define AI_RANGE_N10_10V	0x08
#define AI_RANGE_0_10V		0x09

#define AI_RANGE_0_20MA		0x0a

/* API */
int AIO_Init(void);
/* I/O */
int AIO_Connect(char *ip_str, int port, int tmout_ms, int *socket_fd);

int AIO_Close(int socket_fd);

int AIO_RIO_2017_DO_Read(int socket_fd, int tmout_ms, unsigned char *value);

int AIO_RIO_2017_DO_Write(int socket_fd, int tmout_ms, unsigned char value);

int AIO_RIO_2017_AI_Read(int socket_fd, int tmout_ms, unsigned char start_channel, unsigned char quantity, unsigned char *value_buf, int buf_size, int *value_byte_count);

/* Configure */
int AIO_Cfg_Login(char *ip_str, int port, int tmout_ms, char *password, int *socket_fd);
int AIO_Cfg_Exit(int socket_fd);
int AIO_Cfg_SaveExit(int socket_fd);

int AIO_Cfg_RIO_2017_Get_AI_Enable(int socket_fd, int tmout_ms, int start_channel, int quantity, unsigned char *response_buf, int buf_size, int *response_byte_count);

int AIO_Cfg_RIO_2017_Set_AI_Enable(int socket_fd, int tmout_ms, int start_channel, int quantity, int set_value);

int AIO_Cfg_RIO_2017_Get_AI_Range(int socket_fd, int tmout_ms, int start_channel, int quantity, unsigned char *response_buf, int buf_size, int *response_byte_count);

int AIO_Cfg_RIO_2017_Set_AI_Range(int socket_fd, int tmout_ms, int start_channel, int quantity, unsigned char *request_buf, int buf_size);

#endif
