#include <stdio.h>
#include <stdlib.h>
#include "RIO_2018_AIO.h"

int main(int argc, char *argv[])
{
	int i, ret, fd;
	unsigned char response_buf[8];
	int response_byte_count;

	printf("RIO-2018 DI Read Example.\r\n");

	ret = AIO_Init();
	if (ret != AIO_OK) {
		printf("AIO_Init Error: %d.\r\n", ret);
		return -1;
	}
	
	ret = AIO_Connect("192.168.2.127", 502, 1000, &fd);
	if (ret != AIO_OK) {
		printf("AIO_Connect Error: %d.\r\n", ret);
		return -1;
	}

	ret = AIO_RIO_2018_DI_Read(fd, 100, 1, 2, response_buf, sizeof(response_buf), &response_byte_count);
	if (ret != AIO_OK) {
		printf("AIO_RIO_2018_DI_Read Error: %d.\r\n", ret);
	} else {
		printf("DI Read Response:\r\n");
		for(i=0; (i<response_byte_count)&&(i<sizeof(response_buf)); i++) {
			printf("[%d]:0x%02x\r\n", i, response_buf[i]);
		}
	}

	AIO_Close(fd);

	printf("Example Exit.\r\n");
	return 0;
}


