#ifndef _RIO_2018_AIO_H
#define _RIO_2018_AIO_H

/* Error Code */
#define AIO_OK	0x00
#define AIO_TIMEOUT			1000
#define AIO_DISCONNECTED	1001
#define AIO_MB_EXCEPTION	1002
#define AIO_UNKNOWN_RESP	1003
#define AIO_ARG_ERROR		1004
#define AIO_LOGIN_FAILED	1005

/* API */
int AIO_Init(void);
/* I/O */
int AIO_Connect(char *ip_str, int port, int tmout_ms, int *socket_fd);

int AIO_Close(int socket_fd);

int AIO_RIO_2018_DI_Read(int socket_fd, int tmout_ms, unsigned char start_no, unsigned char quantity, unsigned char *value_buf, int buf_size, int *value_byte_count);

int AIO_RIO_2018_DO_Read(int socket_fd, int tmout_ms, unsigned char *value);

int AIO_RIO_2018_DO_Write(int socket_fd, int tmout_ms, unsigned char value);

int AIO_RIO_2018_TC_Read(int socket_fd, int tmout_ms, unsigned char start_channel, unsigned char quantity, unsigned char *value_buf, int buf_size, int *value_byte_count);

/* Configure */
int AIO_Cfg_Login(char *ip_str, int port, int tmout_ms, char *password, int *socket_fd);
int AIO_Cfg_Exit(int socket_fd);
int AIO_Cfg_SaveExit(int socket_fd);

int AIO_Cfg_RIO_2018_Get_TC_Enable(int socket_fd, int tmout_ms, int start_channel, int quantity, unsigned char *response_buf, int buf_size, int *response_byte_count);

int AIO_Cfg_RIO_2018_Set_TC_Enable(int socket_fd, int tmout_ms, int start_channel, int quantity, int set_value);

#endif
