#include <stdio.h>
#include <stdlib.h>
#include "RIO_2018_AIO.h"

#define AI_RANGE_150MV	0x00
#define AI_RANGE_500MV	0x02
#define AI_RANGE_1V		0x04
#define AI_RANGE_5V		0x06
#define AI_RANGE_10V	0x08
#define AI_RANGE_20MA	0x0a

int main(int argc, char *argv[])
{
	int i, ret, fd, set_val;
	unsigned char response_buf[32];
	int response_byte_count;

	printf("RIO-2018 Set TC enable Example.\r\n");

	ret = AIO_Init();
	if (ret != AIO_OK) {
		printf("AIO_Init Error: %d.\r\n", ret);
		return -1;
	}
	
	ret = AIO_Cfg_Login("192.168.2.127", 5001, 1000, "", &fd);
	if (ret != AIO_OK) {
		printf("AIO_Cfg_Login Error: %d.\r\n", ret);
		return -1;
	}

	ret = AIO_Cfg_RIO_2018_Get_TC_Enable(fd, 100, 1, 3, response_buf, sizeof(response_buf), &response_byte_count);
	if (ret != AIO_OK) {
		printf("AIO_Cfg_RIO_2018_Get_TC_Enable Error: %d.\r\n", ret);
		if (ret == AIO_UNKNOWN_RESP) {
			printf("unknown response: %s\r\n", response_buf);
		}
	} else {
		printf("Get AI_Enable:\r\n");
		for(i=0; (i<response_byte_count)&&(i<sizeof(response_buf)); i++) {
			printf("[%d]:0x%02x\r\n", i, response_buf[i]);
		}
	}

	set_val = 0x02;
	ret = AIO_Cfg_RIO_2018_Set_TC_Enable(fd, 100, 1, 3, set_val);
	if (ret != AIO_OK) {
		printf("AIO_Cfg_RIO_2018_Set_TC_Enable Error: %d.\r\n", ret);
	} else {
		printf("Set AI_Enable 0x%x OK\r\n", set_val);
	}

	AIO_Cfg_SaveExit(fd);

	printf("Example Exit.\r\n");
	return 0;
}


